# Use commit instead of v2.5.0
%global commit dd0382995a30f9f108250e98499072abd354945f
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Summary:        OpenTenBase Database Management System
Name:           OpenTenBase
Version:        2.5.0
Release:        3%{?dist}
License:        BSD-3-Clause
URL:            https://www.opentenbase.org/
%if 0%{?shortcommit:1}
Source0:        https://github.com/OpenTenBase/OpenTenBase/archive/%{commit}/OpenTenBase-%{shortcommit}.tar.gz
%else
Source0:        https://github.com/OpenTenBase/%{name}/archive/refs/tags/v%{version}.tar.gz
%endif

BuildRequires:  gcc make
BuildRequires:  readline-devel zlib-devel openssl-devel uuid-devel bison flex
BuildRequires:  perl
Requires:       readline zlib openssl-libs uuid
# provides pg* bin, which conflicts with postgresql
# provides libpq.so, which conflicts with libpq
Conflicts:      postgresql-server libpq
# provides libecpg.so/libpgtypes.so, which conflicts with libecpg/libpgtypes
Conflicts:      libecpg libpgtypes


%description
OpenTenBase is an advanced enterprise-level database management system based on prior work of 
Postgres-XL project. It supports an extended subset of the SQL standard, including transactions, 
foreign keys, user-defined types and functions. Additional, it adds parallel computing, security, 
management, audit and other functions.

%package devel
Summary: Development files for %{name}
Requires:       %{name} = %{version}-%{release}
# provides libpq*.h, which conflicts with libpq-devel
Conflicts:      libpq-devel
# provides ecpg*.h, which conflicts with libecpg
Conflicts:      libecpg-devel

%description devel
This package contains the header files and libraries needed to compile C or C++ applications 
which will directly interact with the OpenTenBase.

%prep
%autosetup  %{?shortcommit:-n %{name}-%{commit}}

%build
chmod +x configure*
export CFLAGS="-g -fPIE"
export LDFLAGS="-fPIE"
%configure --enable-user-switch --with-openssl --with-ossp-uuid --disable-rpath
%make_build

%install
%make_install
pushd contrib
chmod +x pgxc_ctl/make_signature
%make_build
%make_install
popd

%files
%license LICENSE.txt
%doc README.md 
%doc %{_docdir}/postgresql/extension/*.example
%{_bindir}/*
%{_libdir}/libecpg.so*
%{_libdir}/libecpg_compat.so*
%{_libdir}/libpgtypes.so*
%{_libdir}/libpq.so*
%{_libdir}/postgresql
%{_datadir}/postgresql
%dir %{_includedir}/postgresql
%dir %{_libdir}/pkgconfig

%files devel
%{_includedir}/*.h
%{_includedir}/libpq
%{_includedir}/libpq-events.h
%{_includedir}/libpq-fe.h
%{_includedir}/postgresql
%{_libdir}/*.a
%{_libdir}/pkgconfig/*.pc

%changelog
* Tue Nov 7 2023 Wang Guodong <gordonwwang@tencent.com> - 2.5.0-3
- Conflicts with libecpg

* Thu Nov 2 2023 Wang Guodong <gordonwwang@tencent.com> - 2.5.0-2
- Conflicts with libpq, postgresql-server

* Mon Oct 30 2023 Wang Guodong <gordonwwang@tencent.com> - 2.5.0-1
- initial build
